DROP TABLE IF EXISTS customer CASCADE;

CREATE TABLE customer (
	id BIGSERIAL PRIMARY KEY,
	firstname VARCHAR(128) NOT NULL,
	surname VARCHAR(128),
	birthday TIMESTAMP,
	address VARCHAR(256)
);

DROP TABLE IF EXISTS account CASCADE;

CREATE TABLE account (
	id BIGSERIAL PRIMARY KEY,
	customer_id BIGINT REFERENCES customer(id),
	account_number BIGSERIAL NOT NULL,
	balance NUMERIC(19, 2) NOT NULL,
	active BOOLEAN NOT NULL DEFAULT TRUE
);

DROP TABLE IF EXISTS users CASCADE;

CREATE TABLE users (
  id BIGSERIAL PRIMARY KEY,
  name VARCHAR(128) NOT NULL,
  email VARCHAR(64) NOT NULL,
  username VARCHAR(64) NOT NULL,
  password VARCHAR(64) NOT NULL,
  enabled BOOLEAN NOT NULL DEFAULT TRUE,
  UNIQUE(username),
  UNIQUE(email)
);

DROP TABLE IF EXISTS role CASCADE;

CREATE TABLE role (
  id BIGSERIAL PRIMARY KEY,
  name VARCHAR(32) NOT NULL
);

DROP TABLE IF EXISTS user_role;

CREATE TABLE user_role (
  id BIGSERIAL PRIMARY KEY,
  user_id BIGSERIAL REFERENCES users(id),
  role_id BIGSERIAL REFERENCES role(id),
  UNIQUE (user_id, role_id)
);
